# -*- coding: utf-8 -*-

from netgen.csg import *
from ngsolve import *

geo = CSGeometry()
br1 = OrthoBrick (Pnt(0,0,0), Pnt(1,1,1))
br2 = OrthoBrick (Pnt(0.2,0.2,0.2), Pnt(0.8, 0.8, 0.8))
geo.Add (br2.mat("inner"))
geo.Add ( (br1-br2).mat("outer") )

mesh = Mesh(geo.GenerateMesh(maxh=0.3))
fes = L2(mesh, order=2)

gfu = GridFunction(fes)
gfu.Set(x*y)

bfv = BoundaryFromVolumeCF(gfu)
Draw (bfv, mesh, "u_on_surface")


#func_domain2 = CoefficientFunction ([None, specialcf.normal(3)] )
# should lead to same result in my opinion:
func_domain2 = CoefficientFunction ([specialcf.normal(3) if mat== "outer" else (0,0,0) for mat in mesh.GetMaterials()])
# Missing normals on the "inner boundary surface"


bfv2 = BoundaryFromVolumeCF(func_domain2)
Draw (bfv2, mesh, "normal-vec_from_domain_2")


# VTKOutput object
# Paraview-Export -------------------------------------------------------------------------------------------------
# Problem: Can't see the normal vectors in the file?!
vtk = VTKOutput(ma=mesh,
               coefs=[bfv2],
               names = ["Normals"],
                filename="result_normal",
                subdivision=0)
vtk.Do()
